{
  "module_spec": {
    "commands": [
      {
        "command_args": [
          {
            "item_name": "pid", 
            "item_optional": true, 
            "item_type": "integer"
          }
        ], 
        "command_description": "Shut down authoritative DNS server", 
        "command_name": "shutdown"
      }, 
      {
        "command_args": [], 
        "command_description": "Retrieve statistics data", 
        "command_name": "getstats"
      }, 
      {
        "command_args": [
          {
            "item_default": "IN", 
            "item_name": "class", 
            "item_optional": true, 
            "item_type": "string"
          }, 
          {
            "item_default": "", 
            "item_name": "origin", 
            "item_optional": false, 
            "item_type": "string"
          }
        ], 
        "command_description": "(Re)load a specified zone", 
        "command_name": "loadzone"
      }, 
      {
        "command_args": [], 
        "command_description": "(Re)start internal forwarding of DDNS Update messages. This is automatically called if b10-ddns is started, and is not expected to be called by administrators; it will be removed as a public command in the future.", 
        "command_name": "start_ddns_forwarder"
      }, 
      {
        "command_args": [], 
        "command_description": "Stop internal forwarding of DDNS Update messages. This is automatically called if b10-ddns is stopped, and is not expected to be called by administrators; it will be removed as a public command in the future.", 
        "command_name": "stop_ddns_forwarder"
      }
    ], 
    "config_data": [
      {
        "item_default": "/var/bind10/zone.sqlite3", 
        "item_name": "database_file", 
        "item_optional": true, 
        "item_type": "string"
      }, 
      {
        "item_default": [], 
        "item_name": "datasources", 
        "item_optional": true, 
        "item_type": "list", 
        "list_item_spec": {
          "item_default": {}, 
          "item_name": "list_element", 
          "item_optional": false, 
          "item_type": "map", 
          "map_item_spec": [
            {
              "item_default": "", 
              "item_name": "type", 
              "item_optional": false, 
              "item_type": "string"
            }, 
            {
              "item_default": "IN", 
              "item_name": "class", 
              "item_optional": false, 
              "item_type": "string"
            }, 
            {
              "item_default": [], 
              "item_name": "zones", 
              "item_optional": false, 
              "item_type": "list", 
              "list_item_spec": {
                "item_default": {
                  "file": "", 
                  "origin": ""
                }, 
                "item_name": "list_element", 
                "item_optional": true, 
                "item_type": "map", 
                "map_item_spec": [
                  {
                    "item_default": "", 
                    "item_name": "origin", 
                    "item_optional": false, 
                    "item_type": "string"
                  }, 
                  {
                    "item_default": "", 
                    "item_name": "file", 
                    "item_optional": false, 
                    "item_type": "string"
                  }, 
                  {
                    "item_name": "filetype", 
                    "item_optional": true, 
                    "item_type": "string"
                  }
                ]
              }
            }
          ]
        }
      }, 
      {
        "item_default": [
          {
            "address": "::", 
            "port": 53
          }, 
          {
            "address": "0.0.0.0", 
            "port": 53
          }
        ], 
        "item_name": "listen_on", 
        "item_optional": false, 
        "item_type": "list", 
        "list_item_spec": {
          "item_default": {}, 
          "item_name": "address", 
          "item_optional": false, 
          "item_type": "map", 
          "map_item_spec": [
            {
              "item_default": "::1", 
              "item_name": "address", 
              "item_optional": false, 
              "item_type": "string"
            }, 
            {
              "item_default": 53, 
              "item_name": "port", 
              "item_optional": false, 
              "item_type": "integer"
            }
          ]
        }
      }, 
      {
        "item_default": 5000, 
        "item_name": "tcp_recv_timeout", 
        "item_optional": false, 
        "item_type": "integer"
      }
    ], 
    "module_description": "Authoritative service", 
    "module_name": "Auth", 
    "statistics": [
      {
        "item_default": {
          "_SERVER_": {
            "authqryrej": 0, 
            "opcode": {
              "iquery": 0, 
              "notify": 0, 
              "other": 0, 
              "query": 0, 
              "status": 0, 
              "update": 0
            }, 
            "qryauthans": 0, 
            "qrynoauthans": 0, 
            "qrynxrrset": 0, 
            "qryreferral": 0, 
            "qrysuccess": 0, 
            "rcode": {
              "badvers": 0, 
              "formerr": 0, 
              "noerror": 0, 
              "notauth": 0, 
              "notimp": 0, 
              "notzone": 0, 
              "nxdomain": 0, 
              "nxrrset": 0, 
              "other": 0, 
              "refused": 0, 
              "servfail": 0, 
              "yxdomain": 0, 
              "yxrrset": 0
            }, 
            "request": {
              "badednsver": 0, 
              "badsig": 0, 
              "dnssec_ok": 0, 
              "edns0": 0, 
              "sig0": 0, 
              "tcp": 0, 
              "tsig": 0, 
              "udp": 0, 
              "v4": 0, 
              "v6": 0
            }, 
            "response": {
              "edns0": 0, 
              "sig0": 0, 
              "truncated": 0, 
              "tsig": 0
            }, 
            "responses": 0
          }
        }, 
        "item_description": "Zone statistics items. Items for all zones are stored in '_SERVER_'.", 
        "item_name": "zones", 
        "item_optional": false, 
        "item_title": "Zone statistics", 
        "item_type": "named_set", 
        "named_set_item_spec": {
          "item_default": {}, 
          "item_name": "zone", 
          "item_optional": false, 
          "item_type": "map", 
          "map_item_spec": [
            {
              "item_default": {
                "badednsver": 0, 
                "badsig": 0, 
                "dnssec_ok": 0, 
                "edns0": 0, 
                "sig0": 0, 
                "tcp": 0, 
                "tsig": 0, 
                "udp": 0, 
                "v4": 0, 
                "v6": 0
              }, 
              "item_description": "Request statistics", 
              "item_name": "request", 
              "item_optional": false, 
              "item_title": "request", 
              "item_type": "map", 
              "map_item_spec": [
                {
                  "item_default": 0, 
                  "item_description": "Number of IPv4 requests received by the b10-auth server.", 
                  "item_name": "v4", 
                  "item_optional": false, 
                  "item_title": "request.v4", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of IPv6 requests received by the b10-auth server.", 
                  "item_name": "v6", 
                  "item_optional": false, 
                  "item_title": "request.v6", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with EDNS0 received by the b10-auth server.", 
                  "item_name": "edns0", 
                  "item_optional": false, 
                  "item_title": "request.edns0", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with unsupported EDNS version received by the b10-auth server.", 
                  "item_name": "badednsver", 
                  "item_optional": false, 
                  "item_title": "request.badednsver", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with TSIG received by the b10-auth server.", 
                  "item_name": "tsig", 
                  "item_optional": false, 
                  "item_title": "request.tsig", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with SIG(0) received by the b10-auth server; currently not implemented in BIND 10.", 
                  "item_name": "sig0", 
                  "item_optional": false, 
                  "item_title": "request.sig0", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with invalid TSIG or SIG(0) signature received by the b10-auth server.", 
                  "item_name": "badsig", 
                  "item_optional": false, 
                  "item_title": "request.badsig", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of UDP requests received by the b10-auth server.", 
                  "item_name": "udp", 
                  "item_optional": false, 
                  "item_title": "request.udp", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of TCP requests received by the b10-auth server.", 
                  "item_name": "tcp", 
                  "item_optional": false, 
                  "item_title": "request.tcp", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests with \"DNSSEC OK\" (DO) bit was set received by the b10-auth server.", 
                  "item_name": "dnssec_ok", 
                  "item_optional": false, 
                  "item_title": "request.dnssec_ok", 
                  "item_type": "integer"
                }
              ]
            }, 
            {
              "item_default": {
                "iquery": 0, 
                "notify": 0, 
                "other": 0, 
                "query": 0, 
                "status": 0, 
                "update": 0
              }, 
              "item_description": "OpCode statistics", 
              "item_name": "opcode", 
              "item_optional": false, 
              "item_title": "opcode", 
              "item_type": "map", 
              "map_item_spec": [
                {
                  "item_default": 0, 
                  "item_description": "Number of OpCode=Query requests received by the b10-auth server.", 
                  "item_name": "query", 
                  "item_optional": false, 
                  "item_title": "opcode.query", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of OpCode=IQuery requests received by the b10-auth server.", 
                  "item_name": "iquery", 
                  "item_optional": false, 
                  "item_title": "opcode.iquery", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of OpCode=Status requests received by the b10-auth server.", 
                  "item_name": "status", 
                  "item_optional": false, 
                  "item_title": "opcode.status", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of OpCode=Notify requests received by the b10-auth server.", 
                  "item_name": "notify", 
                  "item_optional": false, 
                  "item_title": "opcode.notify", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of OpCode=Update requests received by the b10-auth server.", 
                  "item_name": "update", 
                  "item_optional": false, 
                  "item_title": "opcode.update", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests in other OpCode received by the b10-auth server.", 
                  "item_name": "other", 
                  "item_optional": false, 
                  "item_title": "opcode.other", 
                  "item_type": "integer"
                }
              ]
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of responses sent by the b10-auth server.", 
              "item_name": "responses", 
              "item_optional": false, 
              "item_title": "responses", 
              "item_type": "integer"
            }, 
            {
              "item_default": {
                "edns0": 0, 
                "sig0": 0, 
                "truncated": 0, 
                "tsig": 0
              }, 
              "item_description": "Response statistics", 
              "item_name": "response", 
              "item_optional": false, 
              "item_title": "response", 
              "item_type": "map", 
              "map_item_spec": [
                {
                  "item_default": 0, 
                  "item_description": "Number of truncated responses sent by the b10-auth server.", 
                  "item_name": "truncated", 
                  "item_optional": false, 
                  "item_title": "response.truncated", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of responses with EDNS0 sent by the b10-auth server.", 
                  "item_name": "edns0", 
                  "item_optional": false, 
                  "item_title": "response.edns0", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of responses with TSIG sent by the b10-auth server.", 
                  "item_name": "tsig", 
                  "item_optional": false, 
                  "item_title": "response.tsig", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of responses with SIG(0) sent by the b10-auth server; currently not implemented in BIND 10.", 
                  "item_name": "sig0", 
                  "item_optional": false, 
                  "item_title": "response.sig0", 
                  "item_type": "integer"
                }
              ]
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of queries received by the b10-auth server resulted in rcode = NoError and the number of answer RR >= 1.", 
              "item_name": "qrysuccess", 
              "item_optional": false, 
              "item_title": "qrysuccess", 
              "item_type": "integer"
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of queries received by the b10-auth server resulted in authoritative answer.", 
              "item_name": "qryauthans", 
              "item_optional": false, 
              "item_title": "qryauthans", 
              "item_type": "integer"
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of queries received by the b10-auth server resulted in non-authoritative answer.", 
              "item_name": "qrynoauthans", 
              "item_optional": false, 
              "item_title": "qrynoauthans", 
              "item_type": "integer"
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of queries received by the b10-auth server resulted in referral answer.", 
              "item_name": "qryreferral", 
              "item_optional": false, 
              "item_title": "qryreferral", 
              "item_type": "integer"
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of queries received by the b10-auth server resulted in NoError and AA bit is set in the response, but the number of answer RR == 0.", 
              "item_name": "qrynxrrset", 
              "item_optional": false, 
              "item_title": "qrynxrrset", 
              "item_type": "integer"
            }, 
            {
              "item_default": 0, 
              "item_description": "Number of authoritative queries rejected by the b10-auth server.", 
              "item_name": "authqryrej", 
              "item_optional": false, 
              "item_title": "authqryrej", 
              "item_type": "integer"
            }, 
            {
              "item_default": {
                "badvers": 0, 
                "formerr": 0, 
                "noerror": 0, 
                "notauth": 0, 
                "notimp": 0, 
                "notzone": 0, 
                "nxdomain": 0, 
                "nxrrset": 0, 
                "other": 0, 
                "refused": 0, 
                "servfail": 0, 
                "yxdomain": 0, 
                "yxrrset": 0
              }, 
              "item_description": "Rcode statistics", 
              "item_name": "rcode", 
              "item_optional": false, 
              "item_title": "rcode", 
              "item_type": "map", 
              "map_item_spec": [
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 0 (NoError).", 
                  "item_name": "noerror", 
                  "item_optional": false, 
                  "item_title": "rcode.noerror", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 1 (FormErr).", 
                  "item_name": "formerr", 
                  "item_optional": false, 
                  "item_title": "rcode.formerr", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 2 (ServFail).", 
                  "item_name": "servfail", 
                  "item_optional": false, 
                  "item_title": "rcode.servfail", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 3 (NXDomain).", 
                  "item_name": "nxdomain", 
                  "item_optional": false, 
                  "item_title": "rcode.nxdomain", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 4 (NotImp).", 
                  "item_name": "notimp", 
                  "item_optional": false, 
                  "item_title": "rcode.notimp", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 5 (Refused).", 
                  "item_name": "refused", 
                  "item_optional": false, 
                  "item_title": "rcode.refused", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 6 (YXDomain).", 
                  "item_name": "yxdomain", 
                  "item_optional": false, 
                  "item_title": "rcode.yxdomain", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 7 (YXRRSet).", 
                  "item_name": "yxrrset", 
                  "item_optional": false, 
                  "item_title": "rcode.yxrrset", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 8 (NXRRSet).", 
                  "item_name": "nxrrset", 
                  "item_optional": false, 
                  "item_title": "rcode.nxrrset", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 9 (NotAuth).", 
                  "item_name": "notauth", 
                  "item_optional": false, 
                  "item_title": "rcode.notauth", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 10 (NotZone).", 
                  "item_name": "notzone", 
                  "item_optional": false, 
                  "item_title": "rcode.notzone", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in RCODE = 16 (BADVERS).", 
                  "item_name": "badvers", 
                  "item_optional": false, 
                  "item_title": "rcode.badvers", 
                  "item_type": "integer"
                }, 
                {
                  "item_default": 0, 
                  "item_description": "Number of requests received by the b10-auth server resulted in other RCODEs.", 
                  "item_name": "other", 
                  "item_optional": false, 
                  "item_title": "rcode.other", 
                  "item_type": "integer"
                }
              ]
            }
          ]
        }
      }
    ]
  }
}