{
  "module_spec": {
     "module_name": "Xfrout",
     "config_data": [
       {
         "item_name": "transfers_out",
         "item_type": "integer",
         "item_optional": false,
         "item_default": 10
       },
       {
         "item_name": "transfer_acl",
         "item_type": "list",
         "item_optional": false,
         "item_default": [{"action": "ACCEPT"}],
         "list_item_spec":
         {
             "item_name": "acl_element",
             "item_type": "any",
             "item_optional": true,
             "item_default": {"action": "ACCEPT"}
         }
       },
       {
         "item_name": "also_notify",
         "item_type": "list",
         "item_optional": true,
         "item_default": [],
         "list_item_spec":
         {
             "item_name": "also_notify_element",
             "item_type": "map",
             "item_optional": true,
             "item_default": {},
             "map_item_spec": [
               {
                   "item_name": "address",
                   "item_type": "string",
                   "item_optional": false,
                   "item_default": ""
               },
               {
                   "item_name": "port",
                   "item_type": "integer",
                   "item_optional": false,
                   "item_default": 0
               }
             ]
         }
       },
       {
         "item_name": "zone_config",
         "item_type": "list",
         "item_optional": true,
         "item_default": [],
         "list_item_spec":
         {
             "item_name": "zone_config_element",
             "item_type": "map",
             "item_optional": true,
             "item_default": { "origin": "" },
             "map_item_spec": [
               {
                   "item_name": "origin",
                   "item_type": "string",
                   "item_optional": false,
                   "item_default": ""
               },
               {
                   "item_name": "class",
                   "item_type": "string",
                   "item_optional": false,
                   "item_default": "IN"
               },
               {
                   "item_name": "transfer_acl",
                   "item_type": "list",
                   "item_optional": true,
                   "item_default": [{"action": "ACCEPT"}],
                   "list_item_spec":
                   {
                       "item_name": "acl_element",
                       "item_type": "any",
                       "item_optional": true,
                       "item_default": {"action": "ACCEPT"}
                   }
               }
             ]
         }
       }
      ],
      "commands": [
        {
          "command_name": "shutdown",
          "command_description": "Shut down Xfrout",
          "command_args": [
          {
            "item_name": "pid",
            "item_type": "integer",
            "item_optional": true
          }
        ]
        },
        { "command_name": "notify",
          "command_description": "Send notifies for zone",
          "command_args": [
          { "item_name": "zone_name",
            "item_type": "string",
            "item_optional": false,
            "item_default": "" },
          { "item_name": "zone_class",
            "item_type": "string",
            "item_optional": true,
            "item_default": "IN"
          } ]
        }
      ],
      "statistics": [
        {
          "item_name": "zones",
          "item_type": "named_set",
          "item_optional": false,
          "item_default": {
            "_SERVER_" : {
              "notifyoutv4" : 0,
              "notifyoutv6" : 0,
              "xfrrej" : 0,
              "xfrreqdone" : 0
            }
          },
          "item_title": "Zone names",
          "item_description": "A directory name of per-zone statistics",
          "named_set_item_spec": {
            "item_name": "zonename",
            "item_type": "map",
            "item_optional": false,
            "item_default": {},
            "item_title": "Zone name",
            "item_description": "A actual zone name or special zone name _SERVER_ representing an entire server",
            "map_item_spec": [
              {
                "item_name": "notifyoutv4",
                "item_type": "integer",
                "item_optional": false,
                "item_default": 0,
                "item_title": "IPv4 notifies",
                "item_description": "Number of IPv4 notifies per zone name sent out from Xfrout"
              },
              {
                "item_name": "notifyoutv6",
                "item_type": "integer",
                "item_optional": false,
                "item_default": 0,
                "item_title": "IPv6 notifies",
                "item_description": "Number of IPv6 notifies per zone name sent out from Xfrout"
              },
              {
                "item_name": "xfrrej",
                "item_type": "integer",
                "item_optional": false,
                "item_default": 0,
                "item_title": "XFR rejected requests",
                "item_description": "Number of XFR requests per zone name rejected by Xfrout"
              },
              {
                "item_name": "xfrreqdone",
                "item_type": "integer",
                "item_optional": false,
                "item_default": 0,
                "item_title": "Requested zone transfers",
                "item_description": "Number of requested zone transfers completed per zone name"
              }
            ]
          }
        },
        {
          "item_name": "ixfr_running",
          "item_type": "integer",
          "item_optional": false,
          "item_default": 0,
          "item_title": "IXFR running",
          "item_description": "Number of IXFRs in progress"
        },
        {
          "item_name": "axfr_running",
          "item_type": "integer",
          "item_optional": false,
          "item_default": 0,
          "item_title": "AXFR running",
          "item_description": "Number of AXFRs in progress"
        },
        {
          "item_name": "socket",
          "item_type": "map",
          "item_optional": false,
          "item_default": {
            "unixdomain": {
              "open": 0,
              "openfail": 0,
              "close": 0,
              "bindfail": 0,
              "acceptfail": 0,
              "accept": 0,
              "senderr": 0,
              "recverr": 0
            }
          },
          "item_title": "Socket",
          "item_description": "A directory name of socket statistics",
          "map_item_spec": [
            {
              "item_name": "unixdomain",
              "item_type": "map",
              "item_optional": false,
              "item_default": {
                "open": 0,
                "openfail": 0,
                "close": 0,
                "bindfail": 0,
                "acceptfail": 0,
                "accept": 0,
                "senderr": 0,
                "recverr": 0
              },
              "item_title": "UNIX domain",
              "item_description": "A directory name of UNIX domain statistics",
              "map_item_spec": [
                {
                  "item_name": "open",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Open",
                  "item_description": "UNIX domain sockets opened successfully"
                },
                {
                  "item_name": "openfail",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Open failures",
                  "item_description": "UNIX domain sockets open failures"
                },
                {
                  "item_name": "close",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Close",
                  "item_description": "UNIX domain sockets closed"
                },
                {
                  "item_name": "bindfail",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Bind failures",
                  "item_description": "UNIX domain sockets bind failures"
                },
                {
                  "item_name": "acceptfail",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Accept failures",
                  "item_description": "UNIX domain sockets incoming accept failures"
                },
                {
                  "item_name": "accept",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Accept",
                  "item_description": "UNIX domain sockets incoming connections successfully accepted"
                },
                {
                  "item_name": "senderr",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Send errors",
                  "item_description": "UNIX domain sockets send errors"
                },
                {
                  "item_name": "recverr",
                  "item_type": "integer",
                  "item_optional": false,
                  "item_default": 0,
                  "item_title": "Receive errors",
                  "item_description": "UNIX domain sockets receive errors"
                }
              ]
            }
          ]
        }
      ]
  }
}

